#!/usr/bin/perl -w

# Copyright (c) 2001 imacat
# vҦ (c) 2001 ̺
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# {OۥѳnAziHӦۥѳn|] Free Software Foundation
# ^X GNU qΤ@\iұڡ] GNU General Public License ^ĤG
# ӭקMsoGo@{AΪ̦ۥѿܨϥΥsC
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# oGo@{تOƱ楦ΡASOCƦܨSAXSwت
# tOCԲӪpаѾ\ GNU qΤ@\iҡC
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# zӤwgM{@_@ GNU qΤ@\iҪƥCpG٨SAg
# HG Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# ɮצW:	reslog.pl
# ɮ׻:	Perl apache OɺW٤ϸѵ{
# ɮת:	2.0.1
# ɮק@:	̺ <imacat@mail.imacat.idv.tw>
# Z:	2000-12-22
# vr:	(c) 2001 ̺

# Filename:	reslog.pl
# Description:	Perl script to resolve apache log files
# Author:	imacat <imacat@mail.imacat.idv.tw>
# Version:	2.0.1
# Date:		2000-12-22
# Copyright:	(c) 2000,2001 imacat

use 5.005;
use strict;
use Fcntl qw(:flock);
use Socket qw(inet_aton AF_INET);
use IO::Handle qw(autoflush);
use Getopt::Long qw(GetOptions);
use Cwd qw(cwd);
use File::Basename qw(basename fileparse);
use File::Spec::Functions qw(file_name_is_absolute catdir catfile splitdir curdir updir);
use File::Temp qw(tempfile);
use Config qw(%Config);
use Compress::Zlib qw(gzopen);

use vars qw($VERBOSE $IS_PROGBAR %H_ERRNO $SUFFIX $TMP_SUFFIX $STDOUT %NAMES);
$VERBOSE = 1;
$IS_PROGBAR = 0;
%H_ERRNO = (	-1	=>	"NETDB_INTERNAL",
		0	=>	"NETDB_SUCCESS",
		1	=>	"HOST_NOT_FOUND",
		2	=>	"TRY_AGAIN",
		3	=>	"NO_RECOVERY",
		4	=>	"NO_DATA");
$SUFFIX = ".resolved";
*TMP_SUFFIX = \".tmp-reslog";
use vars qw($STDOUT $DEFAULT_STDOUT $OVERRIDE $DEFAULT_OVERRIDE $KEEP $DEFAULT_KEEP);
*DEFAULT_STDOUT = \0;
*DEFAULT_OVERRIDE = \"fail";
*DEFAULT_KEEP = \"delete";

use vars qw($THIS_FILE $SHORTHELP $VERNO $VERSTR $HELPSTR);
$0 =~ /[^\/]*$/;
$THIS_FILE = $&;
$SHORTHELP = "Try `$THIS_FILE --help' for more information.";
$VERNO = "2.0.1";
$VERSTR = "$& v$VERNO by imacat <imacat\@mail.imacat.idv.tw>";
$HELPSTR = << "EOF";
Usage: $THIS_FILE [options] [logfile...]
Reverse resolve IPs from the apache access log.

  -s,--suffix=suf    Set the suffix of the output resolved file. If not
                     specified, the default is "$SUFFIX".
  --override[=mode]  The override behavior when the target file exists.
                     Available modes are: overwrite, append and fail. If not
                     specified, the default is "fail". If specified without
                     mode, the default is "overwrite".
  --keep[=mode]      What to keep in the logfile. Available modes are: all,
                     restart and delete. If not specified, the default is
                     "restart". If specified without mode, the default is
                     "all".
  --stdout           Output the result to STDOUT.
  -d,--debug         Display debugging messages.
  -q,--quiet         Be quiet. Only yell when errors.
  -h,--help          Display this help.
  -v,--version       Display version number.
  logfile            The apache access log file to be resolved.

It will copy the <logfile> to a temporary working file <logfile>.tmp and
restart the <logfile> first. Then it will resolve the <logfile>.tmp. The
result will be appended to the <logfile>$SUFFIX and the temporary
<logfile>.tmp will be removed. If this program crashes during execution,
leaving an unfinished <logfile>.tmp, you can specify -t to force resolving
the <logfile>.tmp.

EOF

main();
exit 0;

# main: Main program D{
sub main {
	local $_;
	my @source;
	my ($ip_counter, $name_counter);
	
	# Parse the arguments ѼƸѪR
	@source = parse_args();
	
	# Resolve each log file @Ӥ@Ӥϸ
	($ip_counter, $name_counter) = (0, 0);
	foreach (@source) {
		# Resolve a log file ϸѤ@ӰO
		@_ = res_log ($_);
		$ip_counter += $_[0];
		$name_counter += $_[1];
	}
	
	print STDERR "$ip_counter IPs found, $name_counter names resolved, " . (time() - $^T) . " seconds elapsed.\n" if $VERBOSE >= 1;
	return;
}

# parse_args: Parse the arguments ѼƸѪR
sub parse_args {
	local $_;
	my (@source, $output, $working, $dir);
	
	# Get the arguments oѼ
	eval {
		local $SIG{__WARN__} = sub { die $_[0]; };
		Getopt::Long::Configure ("no_auto_abbrev");
		GetOptions(	"suffix|s=s"=>\$SUFFIX,
				"override|o:s"=>\$OVERRIDE,
				"keep|k:s"=>\$KEEP,
				"stdout|c!"=>\$STDOUT,
				"debug|d"=>sub { $VERBOSE = 2; },
				"quiet|q"=>sub { $VERBOSE = 0; },
				"help|h"=>sub { print $HELPSTR; exit 0; },
				"version|v"=>sub { print "$VERSTR\n"; exit 0; });
	};
	$! = 1;
	die "$THIS_FILE: $@" if $@;
	if (defined $OVERRIDE) {
		$OVERRIDE = "overwrite" if $OVERRIDE eq "";
		$OVERRIDE = lc $OVERRIDE;
		if ($OVERRIDE eq "o") {
			$OVERRIDE = "overwrite";
		} elsif ($OVERRIDE eq "a") {
			$OVERRIDE = "append";
		} elsif ($OVERRIDE eq "f") {
			$OVERRIDE = "fail";
		}
		if ($OVERRIDE !~ /^(?:overwrite|append|fail)$/) {
			die "$THIS_FILE: unknown override mode: $OVERRIDE";
		}
	}
	if (defined $KEEP) {
		$KEEP = "all" if $KEEP eq "";
		$KEEP = lc $KEEP;
		if ($KEEP eq "a") {
			$KEEP = "all";
		} elsif ($KEEP eq "r") {
			$KEEP = "restart";
		} elsif ($KEEP eq "d") {
			$KEEP = "delete";
		}
		if ($KEEP !~ /^(?:all|restart|delete)$/) {
			die "$THIS_FILE: unknown keep mode: $KEEP";
		}
	}
	
	# Get the rest arguments olѼ
	if (@ARGV > 0) {
		@source = @ARGV;
	} else {
		@source = qw(-);
	}
	
	# Set the verbose level ]wT
	autoflush STDOUT if $VERBOSE >= 2;
	$IS_PROGBAR = 1 if $VERBOSE == 1 && -t STDERR;
	
	# Check the log file ˬdO
	die "$THIS_FILE: which log file do you want to resolve?\n$SHORTHELP\n"
		unless @source > 0;
	die "$THIS_FILE: you can only specify STDIN once\n$SHORTHELP\n"
		if grep ($_ eq "-", @source) > 1;
	foreach (@source) {
		next if $_ eq "-";
		$_ = rel2abs ($_);
		die "$THIS_FILE: no such file or directory: $_\n$SHORTHELP\n"
			unless -e $_;
		die "$THIS_FILE: permission denied: $_\n$SHORTHELP\n"
			unless -r $_ && -w $_;
	}
	
	# STDIN can only go to STDOUT зǿJuзǿX
	if (defined $STDOUT) {
		if (grep ($_ eq "-", @source) > 0 && !$STDOUT) {
			warn "$THIS_FILE: Can't delete the STDIN. Change to keep all.\n";
			$STDOUT = 1;
		}
	} else {
		if (grep ($_ eq "-", @source) > 0) {
			$STDOUT = 1;
		} else {
			$STDOUT = $DEFAULT_STDOUT;
		}
	}
	
	# Set the default override mode ]ww]мgҦ
	if (defined $OVERRIDE) {
	} else {
		$OVERRIDE = $DEFAULT_OVERRIDE;
	}
	
	# Set the default keep mode ]ww]OdҦ
	if (defined $KEEP) {
		# Can't delete STDIN зǿJLkR
		if (grep ($_ eq "-", @source) > 0 && $KEEP eq "delete") {
			warn "$THIS_FILE: Can't delete the STDIN. Change to keep all.\n";
			$KEEP = "all";
		
		# Can't restart STDIN зǿJLkks
		} elsif (grep ($_ eq "-", @source) > 0 && $KEEP eq "restart") {
			warn "$THIS_FILE: Can't restart the STDIN. Change to keep all.\n";
			$KEEP = "all";
		}
	} else {
		if (grep ($_ eq "-", @source) > 0) {
			$KEEP = "all";
		} else {
			$KEEP = $DEFAULT_KEEP;
		}
	}
	
	# Check the output file ˬdXɮ
	if (!$STDOUT) {
		foreach (@source) {
			next if $_ eq "-";
			@_ = fileparse $_, ".gz";
			$dir = $_[1];
			$output = $_[1] . $_[0] . $SUFFIX;
			$working = $_[1] . $_[0] . $TMP_SUFFIX;
			
			# Temporary working exists Ȯɤu@ɤwsb
			die "$THIS_FILE: temporary working file exists: $working\n$SHORTHELP\n"
				if -e $working;
			
			# Output exists -- is it writable? wsbСХiHgJܡH
			if (-e $output) {
				die "$THIS_FILE: file exists: $output\n$SHORTHELP\n"
					if $OVERRIDE eq "fail";
				die "$THIS_FILE: invalid file: $output\n$SHORTHELP\n"
					unless -f $output;
				die "$THIS_FILE: permission denied: $output\n$SHORTHELP\n"
					unless -w $output;
			}
			
			# Is its folder writable? ƧiHgJܡH
			die "$THIS_FILE: no such file or directory: $dir\n$SHORTHELP\n"
				unless -e $dir;
			die "$THIS_FILE: invalid directory: $dir\n$SHORTHELP\n"
				unless -d $dir;
			die "$THIS_FILE: permission denied: $dir\n$SHORTHELP\n"
				unless -w $dir;
		}
	}
	
	return @source;
}

# res_log: Resolve a log file ϸѤ@ӰO
sub res_log {
	local $_;
	my ($source, $working, $output);
	my ($total, $rec_counter, $ip_counter, $name_counter);
	my ($gz, $fh);
	my ($entry, $ip, $pkip);
	$source = $_[0];
	
	($ip_counter, $name_counter) = (0, 0);
	# Open the log file }ҰO
	(*WORKING_SRC, *WORKING_RES, $total, $working)  = open_src ($source);
	return ($ip_counter, $name_counter) if $total == 0;
	
	print STDERR "Resolving entries...\n" if $VERBOSE >= 2;
	$rec_counter = 0;
	while ($entry = <WORKING_SRC>) {
		$rec_counter++;
		$entry =~ /^(\S+)/;
		$ip = $1;
		# Already resolved before dLF
		if (exists $NAMES{$ip}) {
			$entry =~ s/^\S+/$NAMES{$ip}/;
		
		# Not a legal IP -- ignore OT IP СиL
		} elsif ($ip !~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ || !defined ($pkip = inet_aton $ip)) {
		
		# Resolve it da
		} else {
			$ip_counter++;
			print STDERR "[$rec_counter/$total] Looking for [$ip]... " if $VERBOSE >= 2;
			$? = 0 if $? != 0;
			$NAMES{$ip} = gethostbyaddr $pkip, AF_INET;
			# Found dF
			if (defined $NAMES{$ip}) {
				$name_counter++;
				print STDERR "[$NAMES{$ip}]\n" if $VERBOSE >= 2;
			# Not found S
			} else {
				# h_errno not returned S^ h_errno
				if (!defined $?) {
					print STDERR "Failed\n" if $VERBOSE >= 2;
				# h_errno not defined ^Ǫ h_errno bW
				} elsif (!exists $H_ERRNO{$?}) {
					print STDERR "Failed(h_errno = $?)\n" if $VERBOSE >= 2;
				# Report the h_errno constant ^ h-errno N
				} else {
					print STDERR "$H_ERRNO{$?}\n" if $VERBOSE >= 2;
				}
				$NAMES{$ip} = $ip;
			}
			$entry =~ s/^\S+/$NAMES{$ip}/;
		}
		(print WORKING_RES $entry) || die "$THIS_FILE: $!";
		print STDERR progress_bar ($rec_counter, $total) if $IS_PROGBAR;
	}
	print STDERR "\n" if $IS_PROGBAR;
	print STDERR "Resolving done\n" if $VERBOSE >= 2;
	
	# Save the result s
	save_res (*WORKING_RES, *WORKING_SRC, $source, $working);
	return ($ip_counter, $name_counter);
}

# open_src: Open the log file }ҰO
sub open_src {
	local $_;
	my ($source, $working, $target, $total, $gz);
	$source = $_[0];
	
	$total = 0;
	
	# Read the log file from STDIN ѼзǿJŪO
	if ($source eq "-") {
		# Open the temporary working file }ҼȮɤu@
		$target = "temporary working file";
		print STDERR "Creating $target... " if $VERBOSE >= 2;
		*WORKING_SRC = *STDIN;
		(WORKING_SRC = tempfile) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from STDIN to $target... " if $VERBOSE >= 2;
		while ($_ = <STDIN>) {
			(print WORKING_SRC) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
	
	# Gzopen the gzipped file } GZIP ɮ
	} elsif ($source =~ /\.gz$/) {
		# Open the temporary working file }ҼȮɤu@
		if ($KEEP eq "all") {
			$target = "temporary working file";
			print STDERR "Creating $target... " if $VERBOSE >= 2;
			*WORKING_SRC = *STDIN;
			(WORKING_SRC = tempfile) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		
		} else {
			$working = $source;
			$working =~ s/\.gz$//;
			$working .= $TMP_SUFFIX;
			$target = $working;
			print STDERR "Creating $target... " if $VERBOSE >= 2;
			open (WORKING_SRC, "+>$working") || die "$THIS_FILE: $!";
			flock (WORKING_SRC, LOCK_EX) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
		
		# Open the source }ҭO
		print STDERR "Opening $source... " if $VERBOSE >= 2;
		$gz = gzopen($source, "rb") || die "$THIS_FILE: " . $gz->gzerror();
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
		while ($gz->gzreadline($_) > 0) {
			(print WORKING_SRC $_) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Close the source O
		print STDERR "Closing $source... " if $VERBOSE >= 2;
		$gz->gzclose() && die "$THIS_FILE: " . $gz->gzerror();
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Delete the source RO
		if ($KEEP eq "delete") {
			print STDERR "Deleting $source... " if $VERBOSE >= 2;
			unlink ($source) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
	
	# Empty file -- bounce directly ɡСЪ
	} elsif (-z $source) {
		print STDERR "No records read from $source\n" if $VERBOSE >= 1;
		# Delete the source RO
		if ($KEEP eq "delete") {
			print STDERR "Deleting $source... " if $VERBOSE >= 2;
			unlink ($source) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
		return (*STDIN, *STDOUT, 0);
	
	# Ordinary file @ɮ
	# Keep all, copy to temporary file OdOɡAƻsȮɤu@
	} elsif ($KEEP eq "all") {
		# Open the temporary working file }ҼȮɤu@
		$target = "temporary working file";
		print STDERR "Creating $target... " if $VERBOSE >= 2;
		*WORKING_SRC = *STDIN;
		(WORKING_SRC = tempfile) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Open the source }ҭO
		print STDERR "Opening $source... " if $VERBOSE >= 2;
		open (SOURCE, $source) || die "$THIS_FILE: $!";
		flock (SOURCE, LOCK_SH) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
		while ($_ = <SOURCE>) {
			(print WORKING_SRC) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Close the source O
		print STDERR "Closing $source... " if $VERBOSE >= 2;
		flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
		close (SOURCE) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
	
	# Else, copy to temporary file and restart _hAƻsȮɤu@ɨçOks
	} else {
		# Open the temporary working file }ҼȮɤu@
		$working = $source . $TMP_SUFFIX;
		$target = $working;
		print STDERR "Creating $target... " if $VERBOSE >= 2;
		open (WORKING_SRC, "+>$working") || die "$THIS_FILE: $!";
		flock (WORKING_SRC, LOCK_EX) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Open the source }ҭO
		print STDERR "Opening $source... " if $VERBOSE >= 2;
		open (SOURCE, "+<$source") || die "$THIS_FILE: $!";
		flock (SOURCE, LOCK_EX) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
		while ($_ = <SOURCE>) {
			(print WORKING_SRC) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Restart the source Oks
		print STDERR "Restarting $source... " if $VERBOSE >= 2;
		seek (SOURCE, 0, 0) || die "$THIS_FILE: $!";
		truncate (SOURCE, 0) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Close the source O
		print STDERR "Closing $source... " if $VERBOSE >= 2;
		flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
		close (SOURCE) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Delete the source RO
		if ($KEEP eq "delete") {
			print STDERR "Deleting $source... " if $VERBOSE >= 2;
			unlink ($source) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
	}
	
	# Return the file reader ŪgYk
	seek (WORKING_SRC, 0, 0) || die "$THIS_FILE: $!";
	
	$_ = $source;
	$_ = "STDIN" if $_ eq "-";
	print STDERR "" . format_number($total) . " entries found in $_\n" if $VERBOSE >= 1;
	
	# Open the temporary result file }ҼȦsG
	print STDERR "Creating temporary result file... " if $VERBOSE >= 2;
	*WORKING_RES = *STDOUT;
	(WORKING_RES = tempfile) || die "$THIS_FILE: $!";
	print STDERR "done\n" if $VERBOSE >= 2;
	
	return (*WORKING_SRC, *WORKING_RES, $total, $working);
}

# save_res: Save the result xsG
sub save_res {
	local $_;
	my ($source, $working, $output);
	(*WORKING_RES, *WORKING_SRC, $source, $working) = @_;
	
	$output = $source;
	$output =~ s/\.gz$//;
	$output .= $SUFFIX;
	
	# Return the file reader ŪgYk
	seek (WORKING_RES, 0, 0) || die "$THIS_FILE: $!";
	
	# Output to STDOUT gзǿX
	if ($STDOUT) {
		print STDERR "Printing to STDOUT... " if $VERBOSE >= 2;
		print while <WORKING_RES>;
		print STDERR "done\n" if $VERBOSE >= 2;
	
	# Output to a different file gOXɤW
	} else {
		# Append the result to the output file dߵG[XɤW
		print STDERR "Saving results to $output... " if $VERBOSE >= 2;
		if ($OVERRIDE eq "append") {
			open (RESULT, ">>$output") || die "$THIS_FILE: $!";
		} else {
			open (RESULT, ">$output") || die "$THIS_FILE: $!";
		}
		flock (RESULT, LOCK_EX) || die "$THIS_FILE: $!";
		print RESULT while <WORKING_RES>;
		flock (RESULT, LOCK_UN) || die "$THIS_FILE: $!";
		close (RESULT) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
	}
	
	# Close the temporary result file ȦsG
	print STDERR "Closing temporary result file... " if $VERBOSE >= 2;
	flock (WORKING_RES, LOCK_UN) || die "$THIS_FILE: $!";
	close (WORKING_RES) || die "$THIS_FILE: $!";
	print STDERR "done\n" if $VERBOSE >= 2;
	
	# Close the temporary working file Ȯɤu@
	$_ = "temporary working file";
	$_ = $working if defined $working;
	print STDERR "Closing $_... " if $VERBOSE >= 2;
	flock (WORKING_SRC, LOCK_UN) || die "$THIS_FILE: $!";
	close (WORKING_SRC) || die "$THIS_FILE: $!";
	print STDERR "done\n" if $VERBOSE >= 2;
	
	# Delete the temporary working file RȮɤu@
	if (defined $working) {
		print STDERR "Deleting $_... " if $VERBOSE >= 2;
		unlink ($working) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
	}
	
	return;
}

# progress_bar: Obtain the progress bar
sub progress_bar {
	local $_;
	my ($output, $count, $total, $per, $p0, $p1, $p2);
	($count, $total) = @_;
	$per = $count/$total;
	@_ = qw();
	$p0 = sprintf "[%d/$total]", $count;
	$p1 = sprintf "%" . int($per*100/2+0.5) . "s", "";
	$p1 =~ s/ /*/g;
	return sprintf "\r%-19s|%-50s| %6.2f%%", $p0, $p1, $per*100;
}

# format_number: Format the number every 3 digit ƦrCTƥ[@J
sub format_number {
	local $_;
	$_ = $_[0];
	# Group every 3 digit CTƥ[@J
	$_ = $1 . "," . $2 . $3 while /^([^\.]*\d)(\d\d\d)(.*)$/;
	return $_;
}

# rel2abs: Convert a relative path to an absolute path ۹|ର|
sub rel2abs {
	local $_;
	my ($user, $path, $base);
	($path, $base) = @_;
	
	# Turn the base absolute Ҭ۹諸|ন|
	$base = cwd unless defined $base;
	$base = rel2abs ($base) if !file_name_is_absolute $base;
	
	# Deal the ~ home directories under UNIX b UNIX UBz ~ ϥΪ̪ڥؿ
	if (defined $Config{"d_getpwent"}) {
		@_ = splitdir ($path);
		# If start from user's home directory YOqϥΪ̮ڥؿ}l
		if ($_[0] =~ /^~(.*)$/) {
			$user = $1;
			# Get the current user if user not specified YϥΪ̨S]wAHثeϥΪ̬
			$user = getlogin if $user eq "";
			# Get the user home directory oϥΪ̮ڥؿ
			$_ = (getpwnam $user)[7];
			# Replace with the user home directory NϥΪ̮ڥؿ
			$_[0] = $_ if defined $_;
			# Compose the path զX|
			$path = catfile @_;
		}
	}
	
	# Append the current directory if relative ۹|Wثe|
	$path = catdir ($base, $path) unless file_name_is_absolute $path;
	
	@_ = splitdir ($path);			# Split into directory components Uhؿ
	# Add an empty filename level if last level is a directory ̫@hOؿɡA[WťɦWh
	push @_, "" if ($_[@_-1] eq curdir || $_[@_-1] eq updir);
	for ($_ = 1; $_ < @_; $_++) {		# Parse each level one by one @h@hR
		# If it is this directory oӥؿ
		if ($_[$_] eq curdir) {
			splice (@_, $_, 1);	# Remove this level directly ho@h
			$_--;			# The level number drop by 1 hƴ@
		# If it is the parent directory W@hؿ
		} elsif ($_ > 1 && $_[$_] eq updir && $_[$_-1] ne updir) {
			splice (@_, $_-1, 2);	# Remove this and the previous level ho@hMW@h
			$_ -= 2;		# The level number drop by 2 hƴG
		}
	}
	$path = catfile (@_);			# Compose the full path զX|
	return $path;
}

__END__

=head1 NAME

reslog.pl - Resolve the apache log files

=head1 SYNOPSIS

 reslog.pl [options] [logfile...]
 reslog.pl [-h|-v]

=head1 DESCRIPTION

C<reslog.pl> reverse-resolves IPs in the L<apache(8)|apache/8> log
files. These log files can then be analyzed by another program, like
analog. You can treat it as a replacement of L<apache(8)|apache/8>
HostNameLookups directive, which resolves the client IPs altogether
at a later time.

I<Resolving takes long time>. This is mainly caused by resolving, but
not the resolver program itself. To avoid simultaneously writing to
the log file while resolving, which might ruin the log file, it tries
its best. It uses L<flock(2)|flock/2> to prevent simultaneously
writing from other programs (or another instance of itself) that
utilize L<flock(2)|flock/2>. In order to prevent from those that do
not utilize L<flock(2)|flock/2>, like L<httpd(8)|httpd/8>, it
copies the records to a temporary working file first to
maximum reduces the time occupying the log file. 

If it stops in the half of execution, as when the user hits a
C<ctrl-break>, it might leave a temporary working file. The next time
it sees a previous temporary working file, it will refuse to run.
Please process that file first. You can rename and treat it like
another log file. It can then be resolved again.

This prorgam needs temporary working space. After comparing between
memory and disk space, I choose disk space because it is relatively
cheaper and more economic. However, this means that it needs free
temporary disk space about 2 times of the size of the source log file
(10 times if using memory). Please be sure you have that much free
space.

=head1 OPTIONS

=over

=item logfile

The log file to be resolved. If not specified, it will read from
C<STDIN> and output to C<STDOUT>. You could also specify C<-> to read
from C<STDIN>. Multiple log files are supported. If one of these
files are C<STDIN>, it will output to C<STDOUT>. Gzipped files are
supported, too.

=item -s,--suffix=suf

The suffix of the output resolved file. The default suffix is
C<.resolved>.

=item -o,--override[=mode]

Whether we should overwrite the existing resolved files. Currently
the following modes are supported:

=over

=item o,overwrite

Overwrite any existing target file. If C<--override> was specified
without C<mode>, it assumes that you want to overwrite.

=item a,append

Append the records to the existing target file.

=item f,fail

Stop processing whenever a target file exists, to prevent destroying
any existing files by accident. This is the default.

=back

=item -k,--keep[=mode]

What to keep in the original file. Current available modes are:

=over

=item a,all

Keep the source file after records are resolved. If C<--keep> was
specified without C<mode>, it assumes that you want to keep all.

=item r,restart

Restart the source file after records are resolved.

=item d,delete

Delete the source file after records are resolved. This is the
default.

=back

=item -c, --stdout

Output the result to C<STDOUT>.

=item -d, --debug

Show the detailed debugging messages.

=item -q, --quiet

Shihhhhhh. Only yell when errors.

=item -h, --help

Display the help message and exit.

=item -v, --version

Output version information and exit.

=back

=head1 VERSION

2.0.1

=head1 COPYRIGHT

Copyright (c) 2001 imacat. All rights reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but I<WITHOUT ANY WARRANTY>; without even the implied warranty of
I<MERCHANTABILITY> or I<FITNESS FOR A PARTICULAR PURPOSE>.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

=head1 AUTHOR

imacat <imacat@mail.imacat.idv.tw>

=head1 BUGS

Please report if any. ^_*'

=head1 TODO

none

=head1 SEE ALSO

L<gzip(1)|gzip/1>, L<zlib(3)|zlib/3>

=cut
